//
// leute.h
//

#define OBEN            10
#define UNTEN           17
#define KETTE           160

U1 InRange ( short index );
U1 ScanInRange ( short index, short i );
U1 IsDead ( short index );

void MInsert ( short ax, short ay, short dx, short dy, U1 type )
{
  short i;


  MAnz++;
  if ( MAnz >= LMAX/2 ) { MAnz--; return; }

  memset(&Leute[NextFree], 0, sizeof(MANN));

  Leute[NextFree].ax            = ax;
  Leute[NextFree].ay            = ay;
  Leute[NextFree].dx            = dx;
  Leute[NextFree].dy            = dy;
  Leute[NextFree].x             = ax-ScrollX;
  Leute[NextFree].y             = ay-ScrollY;
  Leute[NextFree].type          = type;
  Leute[NextFree].free          = 1;
  Leute[NextFree].who           = 255;
  Leute[NextFree].feind         = 0;
  Leute[NextFree].energie       = Data[type].energie;
  Leute[NextFree].d1count       = 0;
  Leute[NextFree].shape         = type * MANN_DIV;
  Leute[NextFree].kette         = 0;
  Leute[NextFree].zaehler       = 0;

  switch ( type )
  {
    case 8: Leute[NextFree].shapeX  = 53;
            Leute[NextFree].shapeY  = 30;
            Leute[NextFree].shape_start = HELI_START;
            Leute[NextFree].shape = 0;
            break;
    case 9: Leute[NextFree].shapeX = 43;
            Leute[NextFree].shapeY = 30;
            Leute[NextFree].shape_start = KAMPF_START;
            Leute[NextFree].shape = 0;
            break;

    default: Leute[NextFree].shapeX = 20;
             Leute[NextFree].shapeY = 20;
             Leute[NextFree].shape_start = 0;
             break;
  }

  for(i=NextFree; i<LMAX; ++i) if ( !Leute[i].free ) { NextFree = i; return; }
}


void MDelete ( short index )
{
  MAnz--;
  Leute[index].free = 0;

  if ( index < NextFree ) NextFree = index;
}


void FInsert ( short ax, short ay, short dx, short dy, U1 type )
{
  short i;

  FAnz++;
  if ( FAnz >= LMAX/2 ) { FAnz--; return; }

  memset(&Leute[NextFree], 0, sizeof(MANN));

  Leute[NextFree].ax            = ax;
  Leute[NextFree].ay            = ay;
  Leute[NextFree].dx            = dx;
  Leute[NextFree].dy            = dy;
  Leute[NextFree].x             = ax-ScrollX;
  Leute[NextFree].y             = ay-ScrollY;
  Leute[NextFree].type          = type;
  Leute[NextFree].free          = 1;
  Leute[NextFree].who           = 255;
  Leute[NextFree].feind         = 1;
  Leute[NextFree].energie       = Data[type].energie;
  Leute[NextFree].shape         = type * MANN_DIV;
  Leute[NextFree].zaehler       = 0;

  switch ( type )
  {
    default: Leute[NextFree].shapeX = 20;
             Leute[NextFree].shapeY = 20;
             break;
  }

  for(i=NextFree; i<LMAX; ++i) if ( !Leute[i].free ) { NextFree = i; return; }
}


void FDelete ( short index )
{
  FAnz--;
  Leute[index].free = 0;

  if ( index < NextFree ) NextFree = index;
}

void MSet ( short index )
{
  int i, j, farbe =0;
  int k=Leute[index].shape_start+(Leute[index].shape*(Leute[index].shapeX*Leute[index].shapeY));
  U1 puffer;
               
  for ( i=0; i<Leute[index].shapeY; i++ )
  {
    for ( j=0; j<Leute[index].shapeX; j++ )
    {
      if ( ((Leute[index].x+j)<Mrechts)&&((Leute[index].x+j)>Mlinks)&&((Leute[index].y+i)>Moben)&&((Leute[index].y+i)<Munten) )
      {
        if ( LeuteData[k] != 3 )
        {
          puffer = getpix( Leute[index].x+j, Leute[index].y+i);
          if ( puffer < 164 )
          {
            if ( (LeuteData[k] == 0)||(LeuteData[k] == 255) ) setpix( Leute[index].x+j, Leute[index].y+i, farbe);
            else setpix( Leute[index].x+j, Leute[index].y+i, LeuteData[k]);
          }
        }
      }
      k++;
    }
  }
}

void MSetAkt ( short index )
{
  short i, j, farbe =0;
  int k=Leute[index].shape_start+(Leute[index].shape*(Leute[index].shapeX*Leute[index].shapeY));
  U1 puffer;
               
  for ( i=0; i<Leute[index].shapeY; i++ )
  {
    for ( j=0; j<Leute[index].shapeX; j++ )
    {
      if ( ((Leute[index].x+j)<Mrechts)&&((Leute[index].x+j)>Mlinks)&&((Leute[index].y+i)>Moben)&&((Leute[index].y+i)<Munten) )
      {
        if ( LeuteData[k] != 3 )
        {
          puffer = getpix( Leute[index].x+j, Leute[index].y+i);
          if ( puffer < 164 )
          {
            if ( (LeuteData[k] == 0)||(LeuteData[k] == 255) ) setpix( Leute[index].x+j, Leute[index].y+i, farbe);
            else setpix( Leute[index].x+j, Leute[index].y+i, LeuteData[k]);
          }
        }
      }
      k++;
    }
  }

  i = Leute[index].shapeX/2; j = Leute[index].shapeX/4;
  if ( Leute[index].energie <= 0 ) puffer = 1;
  else puffer = (Leute[index].energie*i)/Data[Leute[index].type].energie;


  ssetpix(Leute[index].x+j-1, Leute[index].y+1,   BLAU_DUNKEL);
  ssetpix(Leute[index].x+j-1, Leute[index].y+2,   BLAU_DUNKEL);
  for(k=Leute[index].x+j-1; k<Leute[index].x+j+i+1; k++)
  {
    ssetpix(k, Leute[index].y,   BLAU_DUNKEL);
    ssetpix(k, Leute[index].y+3, BLAU_DUNKEL);
  }
  ssetpix(k-1, Leute[index].y+1,   BLAU_DUNKEL);
  ssetpix(k-1, Leute[index].y+2,   BLAU_DUNKEL);

  for(k=Leute[index].x+j; k<Leute[index].x+j+puffer; k++)
  {
    ssetpix(k, Leute[index].y+1, GELB_HELL);
    ssetpix(k, Leute[index].y+2, GELB_HELL); 
  }
}



U1 IsDead ( short index )
{
  if ( Leute[index].energie <= 0 )
  {
    ExploseInsert(Leute[index].x, Leute[index].y, 10, 22, 1);
    if ( Leute[index].feind ) FDelete(index);
    else MDelete(index);
    return 1;
  }
  return 0;
}


void MannHindernis ( short index )
{

  // RECHTS
  if ( (Karte[Leute[index].ay/20][(Leute[index].ax/20)+1] >= Hindernis)&&(Leute[index].ax < Leute[index].dx) )
  {
    Leute[index].d1[Leute[index].dcount].x = Leute[index].dx;
    Leute[index].d1[Leute[index].dcount].y = Leute[index].dy;

    Leute[index].dx = Leute[index].ax-1;
    if ( Leute[index].ay >= Leute[index].d[0].y ) Leute[index].dy = (YKarte[Leute[index].ay/20][(Leute[index].ax/20)+1].anfang-1)*20;
    else Leute[index].dy = (YKarte[Leute[index].ay/20][(Leute[index].ax/20)+1].ende)*20+10;
    
    Leute[index].d1[Leute[index].dcount+1].x = Leute[index].ax+40;
    Leute[index].d1[Leute[index].dcount+1].y = Leute[index].dy;
    Leute[index].d1count += 1;
    return;
  }  
  // LINKS
  if ( (Karte[Leute[index].ay/20][Leute[index].ax/20] >= Hindernis)&&(Leute[index].ax > Leute[index].dx) )
  {
    Leute[index].d1[Leute[index].d1count].x = Leute[index].dx;
    Leute[index].d1[Leute[index].d1count].y = Leute[index].dy;

    Leute[index].dx = Leute[index].ax+1;
    if ( Leute[index].ay >= Leute[index].d[0].y ) Leute[index].dy = (YKarte[Leute[index].ay/20][Leute[index].ax/20].anfang-1)*20;
    else Leute[index].dy = (YKarte[Leute[index].ay/20][Leute[index].ax/20].ende)*20+10;

    Leute[index].d1[Leute[index].d1count+1].x = Leute[index].ax-30;
    Leute[index].d1[Leute[index].d1count+1].y = Leute[index].dy;
    Leute[index].d1count += 1;
    return;
  }

  // UNTEN
  if ( (Karte[(Leute[index].ay/20)+1][Leute[index].ax/20] >= Hindernis)&&(Leute[index].ay < Leute[index].dy) )
  {
    Leute[index].d1[Leute[index].dcount].x   = Leute[index].dx;
    Leute[index].d1[Leute[index].dcount].y = Leute[index].dy;

    Leute[index].dy = Leute[index].ay-1;
    if ( Leute[index].ax >= Leute[index].d[0].x ) Leute[index].dx = (XKarte[(Leute[index].ay/20)+1][Leute[index].ax/20].anfang-1)*20;
    else Leute[index].dx = (XKarte[(Leute[index].ay/20)+1][Leute[index].ax/20].ende)*20+10;

    Leute[index].d1[Leute[index].dcount+1].x   = Leute[index].dx;
    Leute[index].d1[Leute[index].dcount+1].y = Leute[index].ay+40;
    Leute[index].d1count += 1;
    return;
  }
  // OBEN 
  if ( (Karte[Leute[index].ay/20][Leute[index].ax/20] >= Hindernis)&&(Leute[index].ay > Leute[index].dy) )
  {
    Leute[index].d[Leute[index].dcount].x   = Leute[index].dx;
    Leute[index].d[Leute[index].dcount].y = Leute[index].dy;

    Leute[index].dy = Leute[index].ay+1;
    if ( Leute[index].ax >= Leute[index].d[0].x ) Leute[index].dx = (XKarte[(Leute[index].ay/20)-1][Leute[index].ax/20].anfang-1)*20;
    else Leute[index].dx = (XKarte[(Leute[index].ay/20)-1][Leute[index].ax/20].ende)*20+10;

    Leute[index].d[Leute[index].dcount+1].x   = Leute[index].dx;
    Leute[index].d[Leute[index].dcount+1].y = Leute[index].ay-30;
    Leute[index].d1count += 1;
    return;
  } 

}



void MannMove ( short index )
{
  U1 rechts=0, links=0;
  U1 schritt=1;

  //-- Wird fr die Kollisionsabfrage bentigt --//
  if ( (Leute[index].ax == Leute[index].dx)&&(Leute[index].ay == Leute[index].dy) )
  {
    if ( Leute[index].d1count > 0 )
    {
      Leute[index].dx = Leute[index].d1[Leute[index].d1count].x;
      Leute[index].dy = Leute[index].d1[Leute[index].d1count--].y;
      goto gehen;
    }

    if ( Leute[index].dcount < Leute[index].dmax )
    {
      Leute[index].dx = Leute[index].d[Leute[index].dcount].x;
      Leute[index].dy = Leute[index].d[Leute[index].dcount++].y;
    }
    else
    {
      Leute[index].shape = R_ANFANG+(MANN_DIV*Leute[index].type);
      return;
    }
  }
  //----------------------------------------------------------------//

gehen:

  MannHindernis(index);

//------------------------------ Nach RECHTS ---------------------------------------------------------------------
    if ( Leute[index].ax < Leute[index].dx )
    {
      Leute[index].ax+=schritt; Leute[index].x+=schritt;
      if ( (Leute[index].shape<R_ANFANG+((MANN_DIV*Leute[index].type)))&&((!(Leute[index].ay>Leute[index].dy)) &&(!(Leute[index].ay<Leute[index].dy))) ) Leute[index].shape = R_ANFANG+((MANN_DIV*Leute[index].type));
      if ( (Leute[index].shape>R_ANFANG+((MANN_DIV*Leute[index].type))+R_LANG)&&((!(Leute[index].ay>Leute[index].dy)) &&(!(Leute[index].ay<Leute[index].dy))) ) Leute[index].shape = R_ANFANG+((MANN_DIV*Leute[index].type));
      Leute[index].shape++; rechts= 1; 
    }
//------------------------------ Nach LINKS ---------------------------------
    if ( Leute[index].ax > Leute[index].dx )
    {
      Leute[index].ax-=schritt; Leute[index].x-=schritt;
      if ( (Leute[index].shape>L_ANFANG+((MANN_DIV*Leute[index].type))+L_LANG)&&((!(Leute[index].ay>Leute[index].dy)) &&(!(Leute[index].ay<Leute[index].dy))) ) Leute[index].shape = L_ANFANG+((MANN_DIV*Leute[index].type));
      Leute[index].shape++; links= 1; 
    }
//------------------------------ Nach UNTEN ---------------------------------
    if ( Leute[index].ay < Leute[index].dy )
    {
      Leute[index].ay+=schritt; Leute[index].y+=schritt;
      if ( links )
      {
        if ( Leute[index].shape < LU_ANFANG+((MANN_DIV*Leute[index].type)) ) Leute[index].shape = LU_ANFANG+((MANN_DIV*Leute[index].type))+1;
        if ( Leute[index].shape > LU_ANFANG+((MANN_DIV*Leute[index].type))+LU_LANG ) Leute[index].shape = LU_ANFANG+((MANN_DIV*Leute[index].type))+1;
      }
      if ( rechts )
      {
        if ( Leute[index].shape < RU_ANFANG+((MANN_DIV*Leute[index].type)) ) Leute[index].shape = RU_ANFANG+((MANN_DIV*Leute[index].type))+1;
        if ( Leute[index].shape > RU_ANFANG+((MANN_DIV*Leute[index].type))+RU_LANG ) Leute[index].shape = RU_ANFANG+((MANN_DIV*Leute[index].type))+1;
      }
      if ( (!rechts)&&(!links) )
      {
        if ( Leute[index].shape < U_ANFANG+((MANN_DIV*Leute[index].type)) ) Leute[index].shape = U_ANFANG+((MANN_DIV*Leute[index].type));
        if ( Leute[index].shape > U_ANFANG+((MANN_DIV*Leute[index].type))+U_LANG ) Leute[index].shape = U_ANFANG+((MANN_DIV*Leute[index].type));
        Leute[index].shape++;
      }
      
    }
//------------------------------ Nach OBEN ----------------------------------
    if ( Leute[index].ay > Leute[index].dy )
    {
      Leute[index].ay-=schritt; Leute[index].y-=schritt;
      if ( links )
      {
        if ( Leute[index].shape < LO_ANFANG+((MANN_DIV*Leute[index].type)) ) Leute[index].shape = LO_ANFANG+((MANN_DIV*Leute[index].type))+1;
        if ( Leute[index].shape > LO_ANFANG+((MANN_DIV*Leute[index].type))+LO_LANG ) Leute[index].shape = LO_ANFANG+((MANN_DIV*Leute[index].type))+1;
      }
      if ( rechts )
      {
        if ( Leute[index].shape < RO_ANFANG+((MANN_DIV*Leute[index].type)) ) Leute[index].shape = RO_ANFANG+((MANN_DIV*Leute[index].type))+1;
        if ( Leute[index].shape > RO_ANFANG+((MANN_DIV*Leute[index].type))+RO_LANG ) Leute[index].shape = RO_ANFANG+((MANN_DIV*Leute[index].type))+1;
      }
      if ( (!rechts)&&(!links) )
      {
        if ( Leute[index].shape < O_ANFANG+((MANN_DIV*Leute[index].type)) ) Leute[index].shape = O_ANFANG+((MANN_DIV*Leute[index].type));
        if ( Leute[index].shape > O_ANFANG+((MANN_DIV*Leute[index].type))+O_LANG ) Leute[index].shape = O_ANFANG+((MANN_DIV*Leute[index].type));
        Leute[index].shape++;
      }
      
    }
}


void KampfMove ( short index )
{
  static U1 schritt = 1;

  //-- Wird fr die Kollisionsabfrage bentigt --//
  if ( (Leute[index].ax == Leute[index].dx)&&(Leute[index].ay == Leute[index].dy) )
  {
    if ( Leute[index].d1count > 0 )
    {
      Leute[index].dx = Leute[index].d1[Leute[index].d1count].x;
      Leute[index].dy = Leute[index].d1[Leute[index].d1count--].y;
      goto gehen;
    }

    if ( Leute[index].dcount < Leute[index].dmax )
    {
      Leute[index].dx = Leute[index].d[Leute[index].dcount].x;
      Leute[index].dy = Leute[index].d[Leute[index].dcount++].y;
    }
  }
gehen:
  if ( (Leute[index].ax == Leute[index].dx)&&(Leute[index].ay == Leute[index].dy) ) return;

  MannHindernis(index);
  if ( Leute[index].kette == 2 ) { Leute[index].shape -= KETTE; Leute[index].kette = 0; }

//--------------------------- RECHTS-UNTEN -----------------------------------
  if ( (Leute[index].ax < Leute[index].dx)&&(Leute[index].ay < Leute[index].dy) )
  {
    if ( Leute[index].shape == 11*OBEN ) { Leute[index].x += schritt; Leute[index].ax += schritt; Leute[index].y += schritt; Leute[index].ay += schritt; goto rest; }
    if ( Leute[index].shape < 11*OBEN ) Leute[index].shape+=OBEN;
    if ( Leute[index].shape > 11*OBEN ) Leute[index].shape-=OBEN;
    goto rest;
  }
//--------------------------- RECHTS-OBEN -----------------------------------
  if ( (Leute[index].ax < Leute[index].dx)&&(Leute[index].ay > Leute[index].dy) )
  {
    if ( Leute[index].shape == 5*OBEN ) { Leute[index].x += schritt; Leute[index].ax += schritt; Leute[index].y -= schritt; Leute[index].ay -= schritt; goto rest; }
    if ( Leute[index].shape < 5*OBEN) Leute[index].shape+=OBEN;
    if ( Leute[index].shape > 5*OBEN ) Leute[index].shape-=OBEN;
    goto rest;
  }
//--------------------------- LINKS-UNTEN -------------------------------------
  if ( (Leute[index].ax > Leute[index].dx)&&(Leute[index].ay < Leute[index].dy) )
  {
    if ( Leute[index].shape == 13*OBEN ) { Leute[index].x -= schritt; Leute[index].ax -= schritt; Leute[index].y += schritt; Leute[index].ay += schritt; goto rest; }
    if ( Leute[index].shape < 13*OBEN) Leute[index].shape+=OBEN;
    if ( Leute[index].shape > 13*OBEN ) Leute[index].shape-=OBEN;
    goto rest;
  }
//--------------------------- LINKS-OBEN -------------------------------------
  if ( (Leute[index].ax > Leute[index].dx)&&(Leute[index].ay > Leute[index].dy) )
  {
    if ( Leute[index].shape == 3*OBEN ) { Leute[index].x -= schritt; Leute[index].ax -= schritt; Leute[index].y -= schritt; Leute[index].ay -= schritt; goto rest; }
    if ( Leute[index].shape < 3*OBEN) Leute[index].shape+=OBEN;
    if ( Leute[index].shape > 3*OBEN ) Leute[index].shape-=OBEN;
    goto rest;
  }
//------------------------------ Nach RECHTS ---------------------------------------------------------------------
    if ( Leute[index].ax < Leute[index].dx )
    {
      if ( Leute[index].shape == 8*OBEN ) { Leute[index].x += schritt; Leute[index].ax += schritt; goto rest; }
      if ( Leute[index].shape < 8*OBEN) Leute[index].shape+=OBEN;
      if ( Leute[index].shape > 8*OBEN ) Leute[index].shape-=OBEN;
      goto rest;
    }
    //------------------------------ Nach LINKS ---------------------------------
    if ( Leute[index].ax > Leute[index].dx )
    {
      if ( Leute[index].shape == 0 ) { Leute[index].x -= schritt; Leute[index].ax -= schritt; goto rest; }
      if ( Leute[index].shape > 0 ) Leute[index].shape-=OBEN;
      goto rest;
    }
    //------------------------------ Nach UNTEN ---------------------------------
    if ( Leute[index].ay < Leute[index].dy )
    {
      if ( Leute[index].shape == 12*OBEN ) { Leute[index].y += schritt; Leute[index].ay += schritt; goto rest; }
      if ( Leute[index].shape < 12*OBEN ) Leute[index].shape+=OBEN;
      if ( Leute[index].shape > 12*OBEN ) Leute[index].shape-=OBEN;
      goto rest;
    }
    //------------------------------ Nach OBEN ----------------------------------
    if ( Leute[index].ay > Leute[index].dy )
    {
      if ( Leute[index].shape == 4*OBEN ) { Leute[index].y -= schritt; Leute[index].ay -= schritt; goto rest; }
      if ( Leute[index].shape < 4*OBEN ) Leute[index].shape+=OBEN;
      if ( Leute[index].shape > 4*OBEN ) Leute[index].shape-=OBEN;
    }
rest:
   if ( Leute[index].kette == 1 ) { Leute[index].shape += KETTE; Leute[index].kette = 2; }
   else Leute[index].kette = 1;
}


void HeliMove ( short index )
{
  if ( Leute[index].shape >= 3 ) Leute[index].shape = 0;
  else Leute[index].shape++;
}

void LeuteTrackAttack ( short index )
{
  Leute[index].zx = Leute[Leute[index].who].ax;
  Leute[index].zy = Leute[Leute[index].who].ay;
}


void LeuteAttack ( short index )
{
////-- Nach Rechts schieen --//
  if ( Leute[index].zx > Leute[index].ax )               // Feind weiter rechts
  {
    if ( Leute[index].zy > Leute[index].ay+10 )                  // Rechts unten
    {  
      if ( Leute[index].shape < ANGRIF_RU+((MANN_DIV*Leute[index].type)) ) Leute[index].shape = ANGRIF_RU+((MANN_DIV*Leute[index].type));
      if ( Leute[index].shape > ANGRIF_RU+ANGRIF_RUL+((MANN_DIV*Leute[index].type)) ) Leute[index].shape = ANGRIF_RU+((MANN_DIV*Leute[index].type));
      Leute[index].fire = 1; Leute[index].shape++; goto atack;
    }
    if ( Leute[index].zy < Leute[index].ay+10 ) // Rechts oben
    {
      if ( Leute[index].shape < ANGRIF_RO+((MANN_DIV*Leute[index].type)) ) Leute[index].shape = ANGRIF_RO+((MANN_DIV*Leute[index].type));
      if ( Leute[index].shape > ANGRIF_RO+ANGRIF_ROL+((MANN_DIV*Leute[index].type)) ) Leute[index].shape = ANGRIF_RO+((MANN_DIV*Leute[index].type));
      Leute[index].fire = 1; Leute[index].shape++; goto atack;
    }
    if ( Leute[index].shape < ANGRIF_R+((MANN_DIV*Leute[index].type)) ) Leute[index].shape = ANGRIF_R+((MANN_DIV*Leute[index].type));
    if ( Leute[index].shape > ANGRIF_R+ANGRIF_RL+((MANN_DIV*Leute[index].type)) ) Leute[index].shape = ANGRIF_R+((MANN_DIV*Leute[index].type));
    Leute[index].fire = 1; Leute[index].shape++; goto atack;
  }
////-- Nach Links schieen --//
  if ( Leute[index].zx < Leute[index].ax )     // Nach Links
  {
    if ( Leute[index].zy > Leute[index].ay+10 ) // Links unten
    {
      if ( Leute[index].shape < ANGRIF_LU+((MANN_DIV*Leute[index].type)) ) Leute[index].shape = ANGRIF_LU+((MANN_DIV*Leute[index].type));
      if ( Leute[index].shape > ANGRIF_LU+ANGRIF_LUL+((MANN_DIV*Leute[index].type)) ) Leute[index].shape = ANGRIF_LU+((MANN_DIV*Leute[index].type));
      Leute[index].fire = 1; Leute[index].shape++; goto atack;
    }
    if ( Leute[index].zy < Leute[index].ay+10 ) // Links oben
    {
      if ( Leute[index].shape < ANGRIF_LO+((MANN_DIV*Leute[index].type)) ) Leute[index].shape = ANGRIF_LO+((MANN_DIV*Leute[index].type));
      if ( Leute[index].shape > ANGRIF_LO+ANGRIF_ROL+((MANN_DIV*Leute[index].type)) ) Leute[index].shape = ANGRIF_LO+((MANN_DIV*Leute[index].type));
      Leute[index].fire = 1; Leute[index].shape++; goto atack;
    }
    if ( Leute[index].shape < ANGRIF_L+((MANN_DIV*Leute[index].type)) ) Leute[index].shape = ANGRIF_L+((MANN_DIV*Leute[index].type));
    if ( Leute[index].shape > ANGRIF_L+ANGRIF_LL+((MANN_DIV*Leute[index].type)) ) Leute[index].shape = ANGRIF_L+((MANN_DIV*Leute[index].type));
    Leute[index].fire = 1; Leute[index].shape++; goto atack;
  }  
////-- Nach Oben schieen --//
  if ( Leute[index].zy > Leute[index].ay )
  {
    if ( Leute[index].shape < ANGRIF_U+((MANN_DIV*Leute[index].type)) ) Leute[index].shape = ANGRIF_U+((MANN_DIV*Leute[index].type));
    if ( Leute[index].shape > ANGRIF_U+ANGRIF_UL+((MANN_DIV*Leute[index].type)) ) Leute[index].shape = ANGRIF_U+((MANN_DIV*Leute[index].type));
    Leute[index].fire = 1; Leute[index].shape++; goto atack;
  }
////-- Nach Unten schieen --//
  if ( Leute[index].zy <= Leute[index].ay )
  {
    if ( Leute[index].shape < ANGRIF_O+((MANN_DIV*Leute[index].type)) ) Leute[index].shape = ANGRIF_O+((MANN_DIV*Leute[index].type));
    if ( Leute[index].shape > ANGRIF_O+ANGRIF_OL+((MANN_DIV*Leute[index].type)) ) Leute[index].shape = ANGRIF_O+((MANN_DIV*Leute[index].type));
    Leute[index].fire = 1; Leute[index].shape++; goto atack;
  }
     
atack:
  LeuteTrackAttack(index);
}


U1 InRange ( short index )
{
  static long a, b, c;

  a = Leute[index].ax - Leute[index].zx;
  b = Leute[index].ay - Leute[index].zy;
  c = Data[Leute[index].type].weapon_reach*20;
  return( ( a*a+b*b <= c*c ) ? 1:0 );
}

U1 ScanInRange ( short index, short i )
{
  static long a, b, c;

  a = Leute[index].ax - Leute[i].ax;
  b = Leute[index].ay - Leute[i].ay;
  c = Data[Leute[index].type].weapon_reach*20;
  return( ( a*a+b*b <= c*c ) ? 1:0 );
}


void CalcHit ( short index )
{
  static U1 hit;

  hit = rand()%Data[Leute[index].type].hit_security;
  
  Leute[Leute[index].who].energie -= (Data[Leute[index].type].destruct-hit);

  //-- Der mit attack indetifizierte Feind wurde zerstrt --//
  if ( Leute[Leute[index].who].energie <= 0 ) Leute[index].attack = 0;
}


void ShowGoderAttack ( short index )
{
  int x=(Leute[Leute[index].who].x+rand()%20), y=(Leute[Leute[index].who].y+rand()%20);

  ssetpix(x, y, 201); x--; y++; //braun oben
  ssetpix(x, y, 103); x++;
  ssetpix(x, y,  97); x++;
  ssetpix(x, y, 103); x-=4; y++;
}  

void ScanArea ( short index )
{
  static short i;

  for(i=0; i<LMAX; i++)
  {
    if ( (Leute[i].free)&&(Leute[i].feind!=Leute[index].feind)&&(ScanInRange(index, i)) )
    {
      Leute[index].zx = Leute[i].ax;
      Leute[index].zy = Leute[i].ay;
      Leute[index].attack = 1;
      Leute[index].who = i;
    }
  }
}


void LaserMannAttack ( short index )
{
////-- Nach Rechts schieen --//
  if ( Leute[index].zx > Leute[index].ax )               // Feind weiter rechts
  {
    if ( Leute[index].zy+rand()%Data[Leute[index].type].hit_security*Leute[index].shapeX/4 > Leute[index].ay+10 )                  // Rechts unten
    {  
      if ( Leute[index].shape < ANGRIF_RU+((MANN_DIV*Leute[index].type)) ) Leute[index].shape = ANGRIF_RU+((MANN_DIV*Leute[index].type));
      if ( Leute[index].shape > ANGRIF_RU+ANGRIF_RUL+((MANN_DIV*Leute[index].type)) ) { Leute[index].shape = ANGRIF_RU+((MANN_DIV*Leute[index].type)); LaserInsert(Leute[index].ax+14, Leute[index].ay+14, index); }
      Leute[index].fire = 1; Leute[index].shape++; goto atack;
    }
    if ( Leute[index].zy+rand()%Data[Leute[index].type].hit_security*Leute[index].shapeX/4 < Leute[index].ay+10 ) // Rechts oben
    {
      if ( Leute[index].shape < ANGRIF_RO+((MANN_DIV*Leute[index].type)) ) Leute[index].shape = ANGRIF_RO+((MANN_DIV*Leute[index].type));
      if ( Leute[index].shape > ANGRIF_RO+ANGRIF_ROL+((MANN_DIV*Leute[index].type)) ) { Leute[index].shape = ANGRIF_RO+((MANN_DIV*Leute[index].type)); LaserInsert(Leute[index].ax+12, Leute[index].ay+4, index); }
      Leute[index].fire = 1; Leute[index].shape++; goto atack;
    }
    if ( Leute[index].shape < ANGRIF_R+((MANN_DIV*Leute[index].type)) ) Leute[index].shape = ANGRIF_R+((MANN_DIV*Leute[index].type));
    if ( Leute[index].shape > ANGRIF_R+ANGRIF_RL+((MANN_DIV*Leute[index].type)) ) { Leute[index].shape = ANGRIF_R+((MANN_DIV*Leute[index].type)); LaserInsert(Leute[index].ax+19, Leute[index].ay+10, index); }
    Leute[index].fire = 1; Leute[index].shape++; goto atack;
  }
////-- Nach Links schieen --//
  if ( Leute[index].zx+rand()%Data[Leute[index].type].hit_security*Leute[index].shapeX/4 < Leute[index].ax )     // Nach Links
  {
    if ( Leute[index].zy+rand()%Data[Leute[index].type].hit_security*Leute[index].shapeX/4 > Leute[index].ay+10 ) // Links unten
    {
      if ( Leute[index].shape < ANGRIF_LU+((MANN_DIV*Leute[index].type)) ) Leute[index].shape = ANGRIF_LU+((MANN_DIV*Leute[index].type));
      if ( Leute[index].shape > ANGRIF_LU+ANGRIF_LUL+((MANN_DIV*Leute[index].type)) ) { Leute[index].shape = ANGRIF_LU+((MANN_DIV*Leute[index].type)); LaserInsert(Leute[index].ax+3, Leute[index].ay+14, index); }
      Leute[index].fire = 1; Leute[index].shape++; goto atack;
    }
    if ( Leute[index].zy+rand()%Data[Leute[index].type].hit_security*Leute[index].shapeX/4 < Leute[index].ay+10 ) // Links oben
    {
      if ( Leute[index].shape < ANGRIF_LO+((MANN_DIV*Leute[index].type)) ) Leute[index].shape = ANGRIF_LO+((MANN_DIV*Leute[index].type));                                                                                                                                                                                                                                                                           
      if ( Leute[index].shape > ANGRIF_LO+ANGRIF_ROL+((MANN_DIV*Leute[index].type)) ) { Leute[index].shape = ANGRIF_LO+((MANN_DIV*Leute[index].type)); LaserInsert(Leute[index].ax+5, Leute[index].ay+4, index); }
      Leute[index].fire = 1; Leute[index].shape++; goto atack;
    }
    if ( Leute[index].shape < ANGRIF_L+((MANN_DIV*Leute[index].type)) ) Leute[index].shape = ANGRIF_L+((MANN_DIV*Leute[index].type));
    if ( Leute[index].shape > ANGRIF_L+ANGRIF_LL+((MANN_DIV*Leute[index].type)) ) { Leute[index].shape = ANGRIF_L+((MANN_DIV*Leute[index].type)); LaserInsert(Leute[index].ax, Leute[index].ay+10, index); }
    Leute[index].fire = 1; Leute[index].shape++; goto atack;
  }  
////-- Nach Oben schieen --//
  if ( Leute[index].zy+rand()%Data[Leute[index].type].hit_security*Leute[index].shapeX/4 > Leute[index].ay )
  {
    if ( Leute[index].shape < ANGRIF_U+((MANN_DIV*Leute[index].type)) ) Leute[index].shape = ANGRIF_U+((MANN_DIV*Leute[index].type));
    if ( Leute[index].shape > ANGRIF_U+ANGRIF_UL+((MANN_DIV*Leute[index].type)) ) { Leute[index].shape = ANGRIF_U+((MANN_DIV*Leute[index].type)); LaserInsert(Leute[index].ax+11, Leute[index].ay+2, index); }
    Leute[index].fire = 1; Leute[index].shape++; goto atack;
  }
////-- Nach Unten schieen --//
  if ( Leute[index].zy+rand()%Data[Leute[index].type].hit_security*Leute[index].shapeX/4 <= Leute[index].ay )
  {
    if ( Leute[index].shape < ANGRIF_O+((MANN_DIV*Leute[index].type)) ) Leute[index].shape = ANGRIF_O+((MANN_DIV*Leute[index].type));
    if ( Leute[index].shape > ANGRIF_O+ANGRIF_OL+((MANN_DIV*Leute[index].type)) ) { Leute[index].shape = ANGRIF_O+((MANN_DIV*Leute[index].type)); LaserInsert(Leute[index].ax+8, Leute[index].ay+15, index); }
    Leute[index].fire = 1; Leute[index].shape++; goto atack;
  }
     
atack:
  LeuteTrackAttack(index);
}

void RocketMannAttack ( short index )
{
////-- Nach Rechts schieen --//
  if ( Leute[index].zx > Leute[index].ax )               // Feind weiter rechts
  {
    if ( Leute[index].zy > Leute[index].ay+10 )                  // Rechts unten
    {  
      if ( Leute[index].shape < ANGRIF_RU+((MANN_DIV*Leute[index].type)) )
        Leute[index].shape = ANGRIF_RU+((MANN_DIV*Leute[index].type));
      if ( Leute[index].shape > ANGRIF_RU+ANGRIF_RUL+((MANN_DIV*Leute[index].type)) )
      {
        Leute[index].shape = ANGRIF_RU+((MANN_DIV*Leute[index].type));
        RocketInsert(Leute[index].ax, Leute[index].ay, index);
      }
      Leute[index].fire = 1; Leute[index].shape++; goto atack;
    }
    if ( Leute[index].zy < Leute[index].ay+10 ) // Rechts oben
    {
      if ( Leute[index].shape < ANGRIF_RO+((MANN_DIV*Leute[index].type)) )
        Leute[index].shape = ANGRIF_RO+((MANN_DIV*Leute[index].type));
      if ( Leute[index].shape > ANGRIF_RO+ANGRIF_ROL+((MANN_DIV*Leute[index].type)) )
      {
        Leute[index].shape = ANGRIF_RO+((MANN_DIV*Leute[index].type));
        RocketInsert(Leute[index].ax, Leute[index].ay, index);
      }
      Leute[index].fire = 1; Leute[index].shape++; goto atack;
    }
    if ( Leute[index].shape < ANGRIF_R+((MANN_DIV*Leute[index].type)) )
      Leute[index].shape = ANGRIF_R+((MANN_DIV*Leute[index].type));
    if ( Leute[index].shape > ANGRIF_R+ANGRIF_RL+((MANN_DIV*Leute[index].type)) )
    {
      Leute[index].shape = ANGRIF_R+((MANN_DIV*Leute[index].type));
      RocketInsert(Leute[index].ax, Leute[index].ay, index);
    }
    Leute[index].fire = 1; Leute[index].shape++; goto atack;
  }
////-- Nach Links schieen --//
  if ( Leute[index].zx < Leute[index].ax )     // Nach Links
  {
    if ( Leute[index].zy > Leute[index].ay+10 ) // Links unten
    {
      if ( Leute[index].shape < ANGRIF_LU+((MANN_DIV*Leute[index].type)) )
        Leute[index].shape = ANGRIF_LU+((MANN_DIV*Leute[index].type));
      if ( Leute[index].shape > ANGRIF_LU+ANGRIF_LUL+((MANN_DIV*Leute[index].type)) )
      {
        Leute[index].shape = ANGRIF_LU+((MANN_DIV*Leute[index].type));
        RocketInsert(Leute[index].ax, Leute[index].ay, index);
      }
      Leute[index].fire = 1; Leute[index].shape++; goto atack;
    }
    if ( Leute[index].zy < Leute[index].ay+10 ) // Links oben
    {
      if ( Leute[index].shape < ANGRIF_LO+((MANN_DIV*Leute[index].type)) )
        Leute[index].shape = ANGRIF_LO+((MANN_DIV*Leute[index].type));
      if ( Leute[index].shape > ANGRIF_LO+ANGRIF_ROL+((MANN_DIV*Leute[index].type)) )
      {
        Leute[index].shape = ANGRIF_LO+((MANN_DIV*Leute[index].type));
        RocketInsert(Leute[index].ax, Leute[index].ay, index);
      }
      Leute[index].fire = 1; Leute[index].shape++; goto atack;
    }
    if ( Leute[index].shape < ANGRIF_L+((MANN_DIV*Leute[index].type)) )
      Leute[index].shape = ANGRIF_L+((MANN_DIV*Leute[index].type));
    if ( Leute[index].shape > ANGRIF_L+ANGRIF_LL+((MANN_DIV*Leute[index].type)) )
    {
      Leute[index].shape = ANGRIF_L+((MANN_DIV*Leute[index].type));
      RocketInsert(Leute[index].ax, Leute[index].ay, index);
    }
    Leute[index].fire = 1; Leute[index].shape++; goto atack;
  }  
////-- Nach Oben schieen --//
  if ( Leute[index].zy > Leute[index].ay )
  {
    if ( Leute[index].shape < ANGRIF_U+((MANN_DIV*Leute[index].type)) ) Leute[index].shape = ANGRIF_U+((MANN_DIV*Leute[index].type));
    if ( Leute[index].shape > ANGRIF_U+ANGRIF_UL+((MANN_DIV*Leute[index].type)) ) { Leute[index].shape = ANGRIF_U+((MANN_DIV*Leute[index].type)); RocketInsert(Leute[index].ax, Leute[index].ay, index); }
    Leute[index].fire = 1; Leute[index].shape++; goto atack;
  }
////-- Nach Unten schieen --//
  if ( Leute[index].zy <= Leute[index].ay )
  {
    if ( Leute[index].shape < ANGRIF_O+((MANN_DIV*Leute[index].type)) ) Leute[index].shape = ANGRIF_O+((MANN_DIV*Leute[index].type));
    if ( Leute[index].shape > ANGRIF_O+ANGRIF_OL+((MANN_DIV*Leute[index].type)) ) { Leute[index].shape = ANGRIF_O+((MANN_DIV*Leute[index].type)); RocketInsert(Leute[index].ax, Leute[index].ay, index); }
    Leute[index].fire = 1; Leute[index].shape++; goto atack;
  }
     
atack:
  LeuteTrackAttack(index);
}


void MVerhalten ( short index )
{
  //--------------------------------------------------------------//
  if ( Karte[Leute[index].dy/20][Leute[index].dx/20] > Hindernis )
  {
    Leute[index].dx = Leute[index].ax;
    Leute[index].dy = Leute[index].ay;
  }
  //--------------------------------------------------------------//
  if ( (Leute[index].ax == Leute[index].dx)&&(Leute[index].ay == Leute[index].dy) ) ScanArea(index);

  switch (Leute[index].type)
  {
    case 0: if ( IsDead(index) ) return;
            if ( (Leute[index].attack)&&(InRange(index)) )
            {
              LeuteAttack(index);
              ShowGoderAttack(index);
              CalcHit(index);
            }
            else MannMove(index);
            break;

    case 1: if ( IsDead(index) ) return;
            if ( (Leute[index].attack)&&(InRange(index)) )
            {
              if ( Leute[index].zaehler == 0 ) RocketMannAttack(index);
              else Leute[index].zaehler--;
            }
            else MannMove(index);
            break;

    case 2: if ( IsDead(index) ) return;
            if ( (Leute[index].attack)&&(InRange(index)) )
            {
              if ( Leute[index].zaehler == 0 ) LaserMannAttack(index);
              else Leute[index].zaehler--;
            }
            else MannMove(index);
            break;

    case 3: if ( IsDead(index) ) return;
            if ( (Leute[index].attack)&&(InRange(index)) )
            {
              LeuteAttack(index);
              CalcHit(index);
            }
            else MannMove(index);
            break;

    case 4: if ( IsDead(index) ) return;
            if ( (Leute[index].attack)&&(InRange(index)) )
            {
              LeuteAttack(index);
              ShowGoderAttack(index);
              CalcHit(index);
            }
            else MannMove(index);
            break;

    case 5: if ( IsDead(index) ) return;
            if ( (Leute[index].attack)&&(InRange(index)) )
            {
              if ( Leute[index].zaehler == 0 ) RocketMannAttack(index);
              else Leute[index].zaehler--;
            }
            else MannMove(index);
            break;

    case 6: if ( IsDead(index) ) return;
            if ( (Leute[index].attack)&&(InRange(index)) )
            {
              if ( Leute[index].zaehler == 0 ) LaserMannAttack(index);
              else Leute[index].zaehler--;
            }
            else MannMove(index);
            break;

    case 7: if ( IsDead(index) ) return;
            if ( (Leute[index].attack)&&(InRange(index)) )
            {
              LeuteAttack(index);
              CalcHit(index);
            }
            else MannMove(index);
            break;

    case 8: if ( IsDead(index) ) return;
            if ( (Leute[index].attack)&&(InRange(index)) )
            {
              LeuteAttack(index);
              CalcHit(index);
            }
            else HeliMove(index);
            break;

    case 9: if ( IsDead(index) ) return;
            if ( (Leute[index].attack)&&(InRange(index)) )
            {
              CalcHit(index);
            }
            else KampfMove(index);
            break;
  } //switch
}




